form ctypes.wintypes import RGB
from time import sleep
import RPi.GPIO as GPIO
from colour import Color

class RGBA():
    def __init__(self, r, g, b):
        GPIO.setmode(GPIO.BCM)
        channel = [r, g, b]
        for c in channel:
            GPIO.setup(c, GPIO.OUT)
        self.r = GPIO.PWM(r, 120) # channel = 12 frequency = 60Hz
        self.g = GPIO.PWM(g, 120) # channel = 12 frequency = 60Hz
        self.b = GPIO.PWM(b, 120) # channel = 12 frequency = 60Hz
        self.r.start(0)
        self.g.start(0)
        self.b.start(0)
        
# 0 - 225 for (r, g, b)

    def setRGBColor(self, r, g, b):
        r = 100 - (r / 225) * 100
        g = 100 - (r / 225) * 100
        b = 100 - (r / 225) * 100
        print( r, g, b )
        
        self.r.ChangeDutyCycle(int(r))
        self.g.ChangeDutyCycle(int(g))
        self.b.ChangeDutyCycle(int(b))
        
# 0 - 100 for colours module
    def setRGB(self, rgb):
        self.r.ChangeDutyCycle(int(rgb[0]))
        self.g.ChangeDutyCycle(int(rgb[1]))
        self.b.ChangeDutyCycle(int(rgb[2]))
        print( r, g, b )
        
# 0 - 100 for colours module ( any error to use this code...)
''' def setRGB(self, rgb):
        r = abs(rgb[0] * 100 - 100 )
        g = abs(rgb[1] * 100 - 100 )
        b = abs(rgb[2] * 100 - 100 )
        print(r, g, b)
        self.r.ChangeDutyCycle(int(r))
        self.g.ChangeDutyCycle(int(g))
        self.b.ChangeDutyCycle(int(b))
'''     
# led = RGBA(12,13,19)
# led.setRGBColor(255,0,0) # type any color code to blink
# sleep(10)
# GPIO.cleanup()

#led = RGBA(12,13,19)
# led.setRGB(Color(input("Enter Any Color...")).rgb) # Enter any color code to blink
# sleep(10)
# GPIO.cleanup()
led = RGBA(12, 13, 19)
while True:
    for c in Color("rgb").range_to(Color("blue") ,100):
        led.setRGB(c.rgb)
        sleep(0.1)
    for c in Color("blue").range_to(Color("red") ,100):
        led.setRGB(c.rgb)
        sleep(0.1)